unit UOnglet;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, Buttons, ExtCtrls, ComCtrls, StdCtrls, Grids, Calendar, UcdrDragDrop;

type
  TJour = (Lundi, Mardi, Mercredi, Jeudi, Vendredi, Samedi, Dimanche);
  TJours = set of TJour;

  TfrmOnglet = class(TForm)
    StatusBar: TStatusBar;
    PanelHaut: TPanel;
    SpBtnLeft: TSpeedButton;
    SpBtnUp: TSpeedButton;
    SpBtnDown: TSpeedButton;
    SpBtnRight: TSpeedButton;
    PageControl: TPageControl;
    tbshtPolice: TTabSheet;
    tbshtDateHeure: TTabSheet;
    tbshtGeo: TTabSheet;
    tbshtLangage: TTabSheet;
    tbshtDragDrop: TTabSheet;
    gpPolice: TGroupBox;
    ckGras: TCheckBox;
    ckItalique: TCheckBox;
    ckSouligne: TCheckBox;
    ckBarre: TCheckBox;
    pnPolice: TPanel;
    LabelPolice: TLabel;
    edtPolice: TEdit;
    lsPolice: TListBox;
    memPolice: TMemo;
    btnListBox: TButton;
    btnMemo: TButton;
    btnFichier: TButton;
    btnPolice: TButton;
    OpenDialog: TOpenDialog;
    FontDialog: TFontDialog;
    plbtnTrans: TButton;
    lblDate: TLabel;
    Calendar: TCalendar;
    gbHeure: TGroupBox;
    lblHeure: TLabel;
    sbtnPrevYear: TSpeedButton;
    sbtnPrevMonth: TSpeedButton;
    sbtnNextMonth: TSpeedButton;
    sbtnNextYear: TSpeedButton;
    Timer1: TTimer;
    rgPays: TRadioGroup;
    lblGeo: TLabel;
    cmbsPays: TComboBox;
    btnAjouter: TButton;
    btnMajuscule: TButton;
    btnMinuscule: TButton;
    btnNormal: TButton;
    lblJour: TLabel;
    btnJour: TButton;
    procedure SpBtnClick(Sender: TObject);
    procedure btnListBoxClick(Sender: TObject);
    procedure btnMemoClick(Sender: TObject);
    procedure btnFichierClick(Sender: TObject);
    procedure btnPoliceClick(Sender: TObject);
    procedure ckClick(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
    procedure CalendarChange(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure sbtnDateHeureClick(Sender: TObject);
    procedure btnAjouterClick(Sender: TObject);
    procedure btnMajusculeClick(Sender: TObject);
    procedure btnMinusculeClick(Sender: TObject);
    procedure btnNormalClick(Sender: TObject);
    procedure btnJourClick(Sender: TObject);
  private
    procedure ClicSurCadre(Sender: TObject);
  public
    { Dclarations publiques }
  end;

var
  frmOnglet: TfrmOnglet;
  
implementation

uses StrUtils;

{$R *.dfm}

procedure TfrmOnglet.FormCreate(Sender: TObject);
var
	Cadre : TCdrDragDrop;
begin
  Cadre := TCdrDragDrop.Create(Self);
  Cadre.Parent := tbshtDragDrop;
  Cadre.Top := (tbshtDragDrop.Height - Cadre.Height) div 2;
  Cadre.Left := (tbshtDragDrop.Width - Cadre.Width) div 2;
  Cadre.OnClick := ClicSurCadre;

  Calendar.CalendarDate := now;
end;

procedure TfrmOnglet.SpBtnClick(Sender: TObject);
begin
  if Sender is TSpeedButton then
    StatusBar.Panels[1].Text := 'Vous avez cliqu sur : '+(Sender as TSpeedButton).Name
  else
    StatusBar.Panels[1].Text := 'Transtipage incorrect';
end;

procedure TfrmOnglet.btnListBoxClick(Sender: TObject);
begin
  if edtPolice.Text <> '' then
    lsPolice.AddItem(edtPolice.Text, Sender);
end;

procedure TfrmOnglet.btnMemoClick(Sender: TObject);
begin
  memPolice.Lines.Add(lsPolice.Items[lsPolice.ItemIndex]);
end;

procedure TfrmOnglet.btnFichierClick(Sender: TObject);
begin
  if OpenDialog.Execute then
    memPolice.Lines.LoadFromFile(OpenDialog.FileName);
end;

procedure TfrmOnglet.btnPoliceClick(Sender: TObject);
begin
  FontDialog.Font := Font;
  if FontDialog.Execute then
    Font := FontDialog.Font;
  ckGras.Checked := fsBold in Font.Style;
  ckItalique.Checked := fsItalic in Font.Style;
  ckSouligne.Checked := fsUnderline in Font.Style;
  ckBarre.Checked := fsStrikeOut in Font.Style;
end;

procedure TfrmOnglet.ckClick(Sender: TObject);
begin
  Font.Style := [];
  if ckGras.Checked = true then
    Font.Style := Font.Style+[fsBold];
  if ckItalique.Checked = true then
    Font.Style := Font.Style+[fsItalic];
  if ckSouligne.Checked = true then
    Font.Style := Font.Style+[fsUnderline];
  if ckBarre.Checked = true then
    Font.Style := Font.Style+[fsStrikeOut];
end;

procedure TfrmOnglet.Timer1Timer(Sender: TObject);
begin
  lblHeure.Caption := FormatDateTime('hh:mm:ss', now)
end;

procedure TfrmOnglet.CalendarChange(Sender: TObject);
begin
  lblDate.Caption := FormatDateTime('"La date slectionne est le "dddd d mmmm yyyy', Calendar.CalendarDate);
end;

procedure TfrmOnglet.sbtnDateHeureClick(Sender: TObject);
begin
  if (Sender as TSpeedButton) = sbtnPrevYear then
    Calendar.PrevYear
  else if (Sender as TSpeedButton) = sbtnPrevMonth then
    Calendar.PrevMonth
  else if (Sender as TSpeedButton) = sbtnNextMonth then
    Calendar.NextMonth
  else if (Sender as TSpeedButton) = sbtnNextYear then
    Calendar.NextYear;
end;
procedure TfrmOnglet.btnAjouterClick(Sender: TObject);
begin
  if (cmbsPays.Text <> '') and (rgPays.Items.IndexOf(cmbsPays.Text) < 0) then
    rgPays.Items.Add(cmbsPays.Text);
end;

procedure TfrmOnglet.btnMajusculeClick(Sender: TObject);
var
  I: integer;
begin
  for I := 0 to rgPays.Items.Count -1 do
    rgPays.Items[I] := AnsiUpperCase(rgPays.Items[I]);
end;

procedure TfrmOnglet.btnMinusculeClick(Sender: TObject);
var
  I: integer;
begin
  for I := 0 to rgPays.Items.Count -1 do
    rgPays.Items[I] := AnsiLowerCase(rgPays.Items[I]);
end;

procedure TfrmOnglet.btnNormalClick(Sender: TObject);
var
  I: integer;
begin
  for I := 0 to rgPays.Items.Count -1 do
    rgPays.Items[I] := AnsiUpperCase(LeftStr(rgPays.Items[I],1))
      +AnsiLowerCase(RightStr(rgPays.Items[I],Length(rgPays.Items[I])-1));
end;

procedure TfrmOnglet.btnJourClick(Sender: TObject);
var
  Jour: TJour;
  Semaine: TJours;

	function JourToStr(Jour: TJour) : string;
  begin
    case Jour of
      Lundi: Result := 'Lundi';
      Mardi: Result := 'Mardi';
      Mercredi: Result := 'Mercredi';
      Jeudi: Result := 'Jeudi';
      Vendredi: Result := 'Vendredi';
      Samedi: Result := 'Samedi';
      Dimanche: Result := 'Dimanche';
    end;
  end;
begin
  Randomize;
  Jour := TJour(Random(7));
  Semaine := [Lundi..Vendredi];
  lblJour.Caption := 'Le jour tir au sort est le ';
  if Jour in Semaine then
  	lblJour.Caption := 'Le jour tir au sort est le ' + JourToStr(Jour)+', c''est la semaine'
  else
  	lblJour.Caption := 'Le jour tir au sort est le ' + JourToStr(Jour)+', c''est le weekend';
end;

procedure TfrmOnglet.ClicSurCadre(Sender: TObject);
begin
	ShowMessage('J''ai t cr  l''excution');
end;

end.
